/////////////////////////////////////////////////////////////////////////////
// --- thread.h ---
//
// J.M.Wehlou, 2001
//
// Description:
//
//	Don't forget to set C++ to use Multithreaded lib 
//	(project settings | C++ | Code generation | Use runtime library)
//
/////////////////////////////////////////////////////////////////////////////

#ifndef THREAD_H
#define THREAD_H
#pragma message("--- thread.h")

// --------------------------------------------------------------------------
// thread class 
//
class thread
{
	unsigned int	m_uiThreadID;
	unsigned long	m_ulThread;
	HANDLE			m_hEvt;		// used for start and stop synch

	static unsigned int __stdcall tfunc ( void* thisptr ) 
	{
		static_cast<thread*>(thisptr)->run();
		return 0;
	}

	virtual void TakeMsg(UINT msg, WPARAM wParam, LPARAM lParam)
	{
		return;
	}

	void run()
	{
		MSG msg;

		// create the message queue
		PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE);

		// we're far enough to let the creator know we're running
		SetEvent(m_hEvt);

		while(true)
		{
			BOOL bRet = GetMessage(&msg, NULL, 0, 0);
			if (0 >= bRet) // just read the specs, it's a "MickeySoft BOOL" and can be TRUE, FALSE or -1 (right on)
			{
				SetEvent(m_hEvt);
				break;	
			}

			TakeMsg(msg.message, msg.wParam, msg.lParam);
		}
	}

public:
	thread() : m_uiThreadID(0), m_ulThread(0)
	{

	}

	void start() 
	{
		m_hEvt		 = CreateEvent(	NULL,			// security attributes
									FALSE,			// manual reset
									FALSE,			// initial state
									NULL);			// name

		m_ulThread = _beginthreadex(	NULL,			// security
										0,				// stack size
										tfunc,			// start address
										this,			// argument list
										0,				// initflag (0 = running, CREATE_SUSPEND = suspended)
										&m_uiThreadID);	// thread address

		if (0 == m_ulThread)
		{
			throw "Could not create thread";
		}

		// now wait until the thread is up and really running
		if (WAIT_OBJECT_0 != WaitForSingleObject(m_hEvt, 10000L))	// 10 seconds
		{
			throw "Timeout waiting for thread to start";
		}
	}

	void stop() 
	{
		PostThreadMessage(m_uiThreadID, WM_QUIT, 0, 0L);
		if (WAIT_OBJECT_0 != WaitForSingleObject(m_hEvt, 10000L))
		{
			throw "Timeout waiting for thread to stop";
		}
	};

	void PostMsg(UINT msg, WPARAM wParam, LPARAM lParam)
	{
		PostThreadMessage(m_uiThreadID, msg, wParam, lParam);
	}

	unsigned int getThreadID() const	{ return m_uiThreadID; }
	unsigned long getThread() const		{ return m_ulThread; }
};



// ----------------------------------------------------------------------- //
#else
#pragma message("--* thread.h already included")
#endif
// ----------------------------------------------------------------------- //
